import 'package:flutter/services.dart';

import 'csound.dart';

class CsoundAndroid implements Csound
{
  static const platform = const MethodChannel('samples.flutter.dev/csound_android');
  String _handler = "";

  CsoundAndroid()
  {
    print("create CsoundAndroid obj");
    _instantiate();
  }

  void _instantiate() async
  {
    try{
      this._handler = await  platform.invokeMethod("csoundCreate");
      print("Created Csound Object");
    } on PlatformException catch(e) {

      print("${e.code} ${e.message}  ${e.details}");
    }

  }


  void startCsound(String txt) async
  {
    try {
      int res = await platform.invokeMethod("csoundStart", {"handler": this._handler, "csd_text": txt});
    } on PlatformException catch(e)
    {
      print("error on csound start");
    }
  }


  @override
  int compileCsd(String csdPath) {
    // TODO: implement compileCsd
    throw UnimplementedError();
  }

  @override
  int compileCsdText(String text) {
    // TODO: implement compileCsdText
    startCsound(text);
    return 0;
    //throw UnimplementedError();
  }

  @override
  int compileOrc(String orc) {
    // TODO: implement compileOrc
    throw UnimplementedError();
  }

  @override
  Future<double> getControlChannel(String channelName) {
    // TODO: implement getControlChannel
    throw UnimplementedError();
  }

  @override
  Future<String> getStringChannel(String channelName) {
    // TODO: implement getStringChannel
    throw UnimplementedError();
  }

  @override
  int perform() {
    // TODO: implement perform
    return 0;
    throw UnimplementedError();
  }

  @override
  int readScore(String text) {
    // TODO: implement readScore
    throw UnimplementedError();
  }

  @override
  void setControlChannel(String channelName, double value) {
    // TODO: implement setControlChannel
  }

  @override
  void setControlChannelCallback(String channelName, Function callback) {
    // TODO: implement setControlChannelCallback
  }

  @override
  void setStringChannel(String channelName, String value) {
    // TODO: implement setStringChannel
  }

  @override
  void setStringChannelCallback(String channelName, Function callback) {
    // TODO: implement setStringChannelCallback
  }

  @override
  void setTable(int table, List<double> values) {
    // TODO: implement setTable
  }

  @override
  void setTableCallback(int table, Function callback) {
    // TODO: implement setTableCallback
  }

  @override
  void stop() {
    // TODO: implement stop
  }

  void setAudioChannelCallback(String name, Function f)
  {
    throw UnimplementedError("Not available for Android");
  }

  @override
  Future<int> getKsmps() {
    // TODO: implement getKsmps
    throw UnimplementedError("Not available on Android");
  }

  @override
  Future<int> getNchnls() {
    // TODO: implement getNchnls
    throw UnimplementedError("Not available on Android");
  }

  @override
  Future<int> getSr() {
    // TODO: implement getSr
    throw UnimplementedError("Not available on Android");
  }

  @override
  Future<double> evalCode(String code) {
    // TODO: implement evalCode
    throw UnimplementedError();
  }

}