
import 'dart:io';
import 'package:path/path.dart' as Path;

class CsoundPathFinder
{
  static String findPath() {
    if(Platform.isLinux) {
      return getLinuxPath();
    } else if(Platform.isWindows)
    {
      return getWindowsPath();
    } else if(Platform.isMacOS)
    {
      return getMacOSPath();
    }
    throw("Csound path not found");
  }


  static String getLinuxPath()
  {
    const String name = "libcsound64.so";

    for(int i = 0; i < linuxPaths.length; i++)
    {
      String path = Path.join(linuxPaths[i], name);
      if(File(path).existsSync()) {
        return path;
      }
    }

    throw("Csound path not found");
  }

  static String getWindowsPath()
  {
    const name = "csound64.dll";
    for(int i = 0; i < windowsPath.length; i++) {
      final String path = Path.join(windowsPath[i], name);
      if(File(path).existsSync()) {
        return path;
      }
    }
    throw("Csound path not found");
  }

  static String getMacOSPath()
  {

    throw("Csound path not found");
  }

  static const List<String> linuxPaths = [
    "/usr/lib",
    "/usr/lib/csound",
    "/usr/local/lib",
    "/usr/local/lib/csound",
    "/usr/lib/x64",
    "/usr/lib/x64/csound",
    "/usr/local/lib/x64",
    "/usr/local/lib/x64/csound",
  ];

  static const List<String> windowsPath = [
    "C:/Program Files/Csound6_x64/bin",
    "C:/Program Files/Csound6_x64/lib",
  ];
}